myfirst/apps/articles/urls.py
from django.urls import path

from . import views # импорт из текущего пакета, где мы находимся

app_name = "articles" # это для правильной урл привязки; чтоб "detail" тянулись только отсюда

urlpatterns = [
    path('', views.index, name = "_index_"),
    # path([route], [view_resolver], name - ?) 
    # урл "acticles/пустая_строка",
    # переход по которому вызовет внутри файла views функцию под названием index.
    # сейчас функция index в моём views.py возвращает просто "Привет, мир!"
    path('<int:article_id>/', views.detail, name = "detail"), # здесь динамически приходит article id и рендерится соотв. статья в отдельной странице
    path('<int:article_id>/leave_comment', views.leave_comment, name = "leave_comment"), # путь для добавления комментариев

] 

myfirst/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('grappelli/', include('grappelli.urls')), # для Grappelli
    path('', include('articles.urls')), # т.е., include([app_name].[routing_file])
    # открывает локальную привязку нашего приложения, и уже из apps/urls.py досматривает путь
    path('admin/', admin.site.urls),
]

myfirst/apps/articles/models.py
import datetime
from django.db import models
from django.utils import timezone

class Article(models.Model): # конвенция именования в единственном числе
    article_title = models.CharField('название статьи', max_length = 200) # CharField требует обязательно второй аргумент
    article_text = models.TextField('текст статьи')
    pub_date = models.DateTimeField('дата публикации')

    def __str__(self): # для удобного отображения названия
        return self.article_title
    
    def was_published_recently(self):
        return self.pub_date >= (timezone.now() - datetime.timedelta(days = 7))
    
    class Meta:
        verbose_name = 'Статья'
        verbose_name_plural = 'Статьи'

class Comment(models.Model):
    article = models.ForeignKey(Article, on_delete = models.CASCADE) # связывает комменты со статьями; второй параметр включает удаление вместе со ст. все комменты
    author_name = models.CharField('имя автора', max_length = 50)
    comment_text = models.CharField('имя автора', max_length = 2500)

    def __str__(self):
        return self.author_name

    class Meta:
        verbose_name = 'Комментарий'
        verbose_name_plural = 'Комментарии'

myfirst/apps/articles/views.py
from django.http import Http404, HttpResponseRedirect
from django.shortcuts import render
from django.urls import reverse
from articles.models import Article # вместо from .models написал articles.models, потому что не импортировало; видимо, это связано с созданием папки apps

def index(request):
    latest_articles_list = Article.objects.order_by('-pub_date')[:5] #
    return render(request, 'articles/list.html', {'latest_articles_list': latest_articles_list})

def detail(request, article_id):
    try:
        article = Article.objects.get(id = article_id)
    except:
        raise Http404("Статья не найдена")

    latest_comments_list = article.comment_set.order_by('-id')[:10]
    return render(request, 'articles/detail.html', {'article': article, 'latest_comments_list': latest_comments_list})

def leave_comment(request, article_id):
    try:
        article = Article.objects.get(id = article_id)
    except:
        raise Http404("Статья не найдена")

    article.comment_set.create(author_name = request.POST['name'], comment_text = request.POST['text'])

    return HttpResponseRedirect( reverse('articles:detail', args = (article.id, )) )

myfirst/templates/articles/detail.html
{% extends 'base.html' %}

{% block title %} article.article_title {% endblock %}

{% block content %}

    <h2>{{article.article_title}}</h2>
    <p>{{article.article_text}}</p>
    <em>{{article.pub_date}}</em>

    {% if article.was_published_recently %}
        Новая статья!
    {% endif %}

    <hr>
        {% if latest_comments_list %}
            {% for comment in latest_comments_list %}
                <p>
                    <strong>{{comment.author_name}}</strong>
                    <p>{{comment.comment_text}}</p>
                </p>
            {% endfor %}
        {% else %}
            Здесь пока ещё нет комментариев. Станьте первым!
        {% endif %}
    <hr>
    <form action="{% url 'articles:leave_comment' article.id %}" method="POST">

        {% csrf_token %}

        <input name="name" type="text" required placeholder="Ваше имя" /><br>
        <textarea name="text" required placeholder="Текст комментария" cols="30" rows="10"></textarea><br>

        <button type="submit">Оставить комментарий</button>
    </form>
{% endblock %}

myfirst/templates/articles/list.html
{% extends 'base.html' %}

{% block title %} Последние статьи {% endblock %}

{% block content %}

    {% if latest_articles_list %}
        {% for article in latest_articles_list %}
            <!--        урл-привязка к articles   айдишник статьи -->
            <p><a href="{% url 'articles:detail' article.id %}">{{ article.article_title }}</a></p>
            <span>{{ article.article_text }}</span>

        {% endfor %}
    {% else %}
        Статьи не найдены
    {% endif %}

{% endblock %}

myfirst/templates/base.html
<!DOCTYPE html>
<html>
    <head>
        <meta charset="UTF-8" />
        <title>{% block title %} Мой сайт {% endblock %}</title>
    </head>
    <body>
        {% block content %} {% endblock %}
    </body>
</html>